<?php
$CSS_for_IE6 = (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6.') !== FALSE) ? '-IE' : '';
$tz = date_default_timezone_get();
date_default_timezone_set('UTC');
// Get user selections
$selection = new ReportSelection();

// If we have a offset posted, we use this when displaying checkout time
$TIMEZONE_OFFSET = $selection->get(RealTime::GUI_TIMEZONE_OFFSET) != "" && is_numeric($selection->get(RealTime::GUI_TIMEZONE_OFFSET)) ? (int) $selection->get(RealTime::GUI_TIMEZONE_OFFSET) : 0;
$CLIENT_TIME = $selection->get(RealTime::GUI_CLIENT_TIME);
$CLIENT_TIME = substr($CLIENT_TIME, 0, 10);
//echo $TIMEZONE_OFFSET . " " . $CLIENT_TIME;  
$odd = false;

// Get user sort selections
$userSortBy = $selection->get(RealTime::GUI_USER_SORTBY);
$userSortAsc = $selection->get(RealTime::GUI_USER_SORTASC);

$overlayFlag = SystemSettings::get(SystemSettings::SERVER_NS . "licensemonitor.overlay.mapping.data", 0);


// Chart display
if ($selection->get("presentation_type") == "chart") {


////////////////
////////////////   CHART VIEW
////////////////
	
?>

<div id="chart">
	<div class="itemHeader<?= $CSS_for_IE6; ?>" id="header">
	<div class="availableHeader<?= $CSS_for_IE6; ?>">
	<p><?= tt("dashboard_license_usage_unused") ?></p>
	</div>
	<div class="usedHeader<?= $CSS_for_IE6; ?>">
	<p><?= tt("dashboard_license_usage_inuse") ?></p>
	</div>
	</div>
<?php

// Find our 1% value, based on the max value (We use 50 as 100%, since we have 50% used and 50% free)
$e = 50 / log($MAX);

foreach ($entries as $i => $entry) {

	//encode quotes
	$name = htmlentities($entry->name, ENT_QUOTES);
	
	// hack to support real sorting with global mappings
	/*
	if ($measurement == 'products' && strstr($name, '## --') && count($realtime->getSelections(RealTime::PRODUCT)) == 0) {
		continue;
	}
	
	if (strstr($name, '## --')) {
		$name = substr($name, strpos($name, '## --')+2);
	}
	*/
	
	// Get data from object
	$usage = $entry->getRealTimeLicenseUsage(true);
	$usageT = $entry->getRealTimeLicenseUsage();
	$total = $entry->getRealTimeTotaltLicenses();
	
	// Support 0 in totalt
	if ($total == 0 && $usageT > 0) {
		$total = $usageT;
	}
	
	// Skip item, if we dont have any users in it
	if (isset($showUsers) && count($realtime->getSelections(RealTime::USER)) != 0 && count($entry->getUsers()) == 0) {
		continue;
	}
	
	else if (isset($showUsers) && count($realtime->getSelections(RealTime::USER)) != 0) {
		$showEntry = false;
		foreach($entry->getUsers() as $user) {
			if ($user->isSelected()) {
				$showEntry = true;
				break;
			}
		}
		if (!$showEntry) continue;		
	}	
		
	// Find % of Available (Natural logarithm)
	$available = log($total - $usageT) * $e;

	// Is data going "out-of-screen"
	$availableCorrected = (!is_nan($available) && $available > 50) ? true : false;
	
	
	// Find % of used (Natural logarithm)
	$used = log($usage) * $e;
	$usedT = 0;
		
	// If usage and usage totalt differs, we need to calculate the used for total
	if ($usage != $usageT) {		
		// Find % of used total (Natural logarithm)
		$usedT = log($usageT) * $e;		
	}
	
	// Don't allow any of the values to pass 50%
	if (!is_nan($available) && $available > 50) $available = 50;
	if (!is_nan($used) && $used > 50) 			$used = 50;
	if (!is_nan($usedT) && $usedT > 50) 		$usedT = 50;
	
	// If we have data, don't allow the % to be smaller than 0.3
	if ($used < 0.3 && $usage >= 1) $used = 0.3;
	if ($available < 0.3 && ($total - $usageT) >= 1) $available = 0.3;

	//hack to replace "&apos;" to single quote in IE: str_replace("&apos;", "'",$entry->name)
?>	
<div class="item<?= $CSS_for_IE6; ?><?= $measurement != "" ? " drilldown" : "" ?>"  onclick="<?= $measurement != "" ? "drillDown('" . $measurement . "', '" . $name . "')" : '' ?>" >
	<?php 
	
		// For all entries that is not a product
		if (!$entry instanceof RealTimeProduct) {
	?>

		<label><?= strlen(str_replace("&apos;", "'",$entry->name))>30 ? trim(substr(str_replace("&apos;", "'",$entry->name), 0, 30))."..." : str_replace("&apos;", "'",$entry->name) ?> (<?= $total == 0 ? "N/A" : $total ?>)</label>	
		<div class="available <?= $availableCorrected ? 'corrected' : '' ?>" style="width: <?= $available ?>%">
			<p><?= $total - $usageT ?></p>
		</div>
		<?php if (isset($usedT)) { ?> <div class="used total" style="width: <?= $usedT ?>%"></div> <?php } ?>	
		<div class="used" style="width: <?= $used ?>%">
			<p><?= $usage ?></p>
		</div>
			
	<?php 
		}
		
		// for product entry, we remove the license usage numbers..
		else {			
	?>
	
		<label value="<?=trim(str_replace("&apos;", "'",$entry->name))?> "<?= (strlen($name)>30) ? 'onmouseover="Scroller.start(this)" onmouseout="Scroller.stop(this)"' : '' ?> ><?= strlen(str_replace("&apos;", "'",$entry->name))>30 ? trim(substr(str_replace("&apos;", "'",$entry->name), 0, 30))."..." : str_replace("&apos;", "'",$entry->name) ?></label>		
		<div class="available <?= $availableCorrected ? 'corrected' : '' ?>" style="width: <?= $available ?>%">
			<div>
			<p><?= "" /*$total - $usageT*/ ?></p>
			</div>
		</div>
		<?php if (isset($usedT)) { ?> <div class="used total" style="width: <?= $usedT ?>%"></div> <?php } ?>	
		<div class="used" style="width: <?= $used ?>%">
			<p><?= $usage ?></p>
		</div>
	
	<?php 
		}
	?>
	<? if($CSS_for_IE6 != '') echo '<div class="licensemonitor-IE"></div>'; ?>
</div>

<?php if (isset($showUsers) && count($entry->getUsers()) != 0) { ?>
<div class="userinfo" id="userInfoList_<?= $name ?>" style="<?= (isset($userblock[$name]) && $userblock[$name]) ? '' : 'display: none;' ?>" >
	<table id="table" class="list">
		<thead>
			<tr>
				<th><a href="javascript:sendUserSorting('name');"><?= tt("dashboard_license_sort_username") ?></a></th>
				<th><a href="javascript:sendUserSorting('host');"><?= tt("dashboard_license_sort_host") ?></a></th>
				<th><a href="javascript:sendUserSorting('time');"><?= tt("dashboard_license_sort_time") ?></a></th>
				<th><a href="javascript:sendUserSorting('count');"><?= tt("dashboard_license_usage_inuse") ?></a></th>
			</tr>
		</thead>	
		<tbody>
		<?php
		foreach($entry->getUsers($userSortBy, $userSortAsc) as $user) {
			$result = null;
			if($overlayFlag > 0){
				//$sql = "SELECT value FROM vData where id='" . $user->name ."' AND length(value) > 0 AND name='cn'";
				$result = $_SESSION["USERDATA"]["SELECTION"][$user->name];
				$displayName="";
				foreach($result as $row){
					//print_r($row);
					if($row['name']=="cn"&& $row['value']!=null) $displayName = $row['value'];
					elseif($row['name']=="givenName"&& $row['value']!=null)$displayName = $row['value'];
					elseif($row['name']=="sn"&& $row['value']!=null)$displayName = $row['value'].", ".$displayName;
				}
				//if($result[1]['name'] == "displayName" || $result[1]['name'] == "name" || $result[1]['name'] == "cn")
				//	$displayName = $result[1]['value'];
			}
			if ($usage != $usageT && !$user->isSelected()) continue;
			$odd = $odd == false ? true : false;
			
			
			// User friendly time since checkout..
			
			// Verify that the start date is not in future
			if (time() > $user->start ) {
				$flag = false;
				$timeSpent = $CLIENT_TIME - $user->start;
				$days = floor($timeSpent / 86400);
				$hours = floor(($timeSpent - ($days * 86400)) / 3600); 
				$minutes = floor(($timeSpent - ($days * 86400) - ($hours * 3600)) / 60);			
				$timeSinceCheckout =  ($days != 0 ? $days . " day(s), " : "") . ($hours != 0 ? $hours . " hour(s), " : "") . $minutes . " minute(s)";				
			}
			
			// .. it is... :~  Flag warning
			else {
				$flag = true;
				$timeSinceCheckout = 'N/A';
			}
			
		?>		
			<tr class="<?= $odd ? 'odd' : 'even' ?>">
				<? if(count($result) > 0 && $overlayFlag > 0){ ?>
					<td class="item drilldown" ><div><img style="float:left; border:0; padding-right:8px" src="/gfx/icons/id_card16.png" /></div><span style="color:#008080;text-decoration:underline" onmouseout="showHideDescription('tiptool<?=$user->name?>', false);" onmouseover="showHideDescription('tiptool<?=$user->name?>', true);"><?= strlen($displayName) > 0 ? $displayName : $user->name; ?></span> </td>				<?}else{?>
					<td ><?= $user->name; ?></td>
				<?}?>
				<td><?= $user->host ?></td>
				<td>
					<div style="float: left;" <?= $flag ? 'class="redflag" title="The checkout time seems to be collected in the future. Please check the clock on your server and client(s)"' : '' ?>><?= date("Y-m-d H:i", $user->start + $TIMEZONE_OFFSET) ?></div>
					<div style="float: right;"><?= $timeSinceCheckout ?></div>
				</td>
				<td><?= $user->count ?></td>
			</tr>					
		<?php } ?>
		</tbody>
	</table>
	
	
</div>
<?php } ?>



<?php
}
?>
</div>


<?php }

////////////////
////////////////   TABLE VIEW
////////////////

else { ?>


<table id="table" class="list">
	<thead>
		<tr>
			<th>Name</th>
			<th>Total Licenses</th>
			<th><?= tt("dashboard_license_usage_unused") ?></th>
			<th><?= tt("dashboard_license_usage_inuse") ?></th>
		</tr>
	</thead>
	<tbody>
<?php


foreach ($entries as $i => $entry) {
	
	// Skip item, if we dont have any users in it
	if (isset($showUsers) && count($realtime->getSelections(RealTime::USER)) != 0 && count($entry->getUsers()) == 0) {
		continue;
	}
	
	else if (isset($showUsers) && count($realtime->getSelections(RealTime::USER)) != 0) {
		$showEntry = false;
		foreach($entry->getUsers() as $user) {
			if ($user->isSelected()) {
				$showEntry = true;
				break;
			}
		}
		if (!$showEntry) continue;		
	}		
	
	$name = htmlspecialchars($entry->name, ENT_QUOTES);
	$usage = $entry->getRealTimeLicenseUsage(true);
	$usageT = $entry->getRealTimeLicenseUsage();
	
	$total = $entry->getRealTimeTotaltLicenses();

	$odd = $odd == false ? true : false;
?>	
		<tr class="<?= $odd ? 'odd' : 'even' ?>">
			<td class="pfname item<?= $measurement != "" ? " drilldown" : "" ?>" " value="<?=trim(str_replace("&apos;", "'",$entry->name))?> "<?= (strlen($name)>30) ? 'onmouseover="Scroller.start(this)" onmouseout="Scroller.stop(this)"' : '' ?> onclick="<?= $measurement != "" ? "drillDown('" . $measurement . "', '" . $name . "')" : '' ?>"><?= strlen(str_replace("&apos;", "'",$entry->name))>30 ? trim(substr(str_replace("&apos;", "'",$entry->name), 0, 30))."..." : str_replace("&apos;", "'",$entry->name) ?></td>
			<td><?= $total == 0 ? "N/A" : $total ?></td>
			<td><?= $total - $usageT ?></td>
			<td><?= $usageT ?></td>
		</tr>

<?php if (isset($showUsers) && count($entry->getUsers()) != 0) { ?>
<tr>
	<td colspan="4" style="margin: 0; padding: 0;">
<div class="userinfo" id="userInfoList_<?= $name ?>" style="<?= (isset($userblock[$name]) && $userblock[$name]) ? '' : 'display: none;' ?>" >
	<table id="table" class="list users">
		<thead>
			<tr>
				<th><a href="javascript:sendUserSorting('name');"><?= tt("dashboard_license_sort_username") ?></a></th>
				<th><a href="javascript:sendUserSorting('host');"><?= tt("dashboard_license_sort_host") ?></a></th>
				<th><a href="javascript:sendUserSorting('time');"><?= tt("dashboard_license_sort_time") ?></a></th>
				<th><a href="javascript:sendUserSorting('count');"><?= tt("dashboard_license_usage_inuse") ?></a></th>
			</tr>
		</thead>	
		<tbody>
		<?php
		$subTotal = 0;
		foreach($entry->getUsers($userSortBy, $userSortAsc) as $user) {
		if($overlayFlag > 0){
				//$sql = "SELECT value FROM vData where id='" . $user->name ."' AND length(value) > 0 AND name='cn'";
				$result = $_SESSION["USERDATA"]["SELECTION"][$user->name];
				$displayName="";
				foreach($result as $row){
					//print_r($row);
					if($row['name']=="cn"&& $row['value']!=null) $displayName = $row['value'];
					elseif($row['name']=="givenName"&& $row['value']!=null)$displayName = $row['value'];
					elseif($row['name']=="sn"&& $row['value']!=null)$displayName = $row['value'].", ".$displayName;
				}
				//if($result[1]['name'] == "displayName" || $result[1]['name'] == "name" || $result[1]['name'] == "cn")
				//	$displayName = $result[1]['value'];
			}
			if ($usage != $usageT && !$user->isSelected()) continue;
			$odd = $odd == false ? true : false;
			$subTotal += $user->count;				
			
			
		// Verify that the start date is not in future
			if (time() > $user->start ) {
				$flag = false;
				$timeSpent = $CLIENT_TIME - $user->start;
				$days = floor($timeSpent / 86400);
				$hours = floor(($timeSpent - ($days * 86400)) / 3600); 
				$minutes = floor(($timeSpent - ($days * 86400) - ($hours * 3600)) / 60);			
				$timeSinceCheckout =  ($days != 0 ? $days . " day(s), " : "") . ($hours != 0 ? $hours . " hour(s), " : "") . $minutes . " minute(s)";				
			}
			
			// .. it is... :~  Flag warning
			else {
				$flag = true;
				$timeSinceCheckout = 'N/A';
			}
		?>		
			<tr class="<?= $odd ? 'odd' : 'even' ?>">
				<? if(count($result) > 0 && $overlayFlag > 0){ ?>
					<td class="item drilldown" ><div><img style="float:left; border:0; padding-right:8px" src="/gfx/icons/id_card16.png" /></div><span style="color:#008080;text-decoration:underline" onmouseout="showHideDescription('tiptool<?=$user->name?>', false);" onmouseover="showHideDescription('tiptool<?=$user->name?>', true);"><?= strlen($displayName) > 0 ? $displayName : $user->name; ?></span> </td>
				<?}else{?>
					<td ><?= $user->name; ?></td>
				<?}?>
				<td><?= $user->host ?></td>
				<td>
					<div style="float: left;" <?= $flag ? 'class="redflag" title="The checkout time seems to be collected in the future. Please check the clock on your server and client(s)"' : '' ?>><?= date("Y-m-d H:i", $user->start + $TIMEZONE_OFFSET) ?></div>
					<div style="float: right;"><?= $timeSinceCheckout ?></div>
				</td>
				<td><?= $user->count ?></td>
			</tr>					
		<?php } ?>
<?php /* ?>		
			<tr>
				<td colspan="4" style="text-align: right;">
				< ? = $subTotal ? >
				</td>
			</tr>
<?php */ ?>
		</tbody>
	</table>
</div>
	</td>
</tr>
<?php } ?>

<?php
}
?>
	</tbody>
</table>

<?php } ?>

		